Loading...
Searching...
No Matches
RDKit::MolDraw2D_detail::DrawTextFTJS Class Reference

`#include <DrawTextFTJS.h>`

Inheritance diagram for RDKit::MolDraw2D_detail::DrawTextFTJS:

## Public Member Functions

| ~DrawTextFTJS () override=default
| DrawTextFTJS (double max_fnt_sz, double min_fnt_sz, const std::string &font_file, emscripten::val &context)
| DrawTextFTJS (const DrawTextFTJS &)=delete
| DrawTextFTJS (DrawTextFTJS &&)=delete
DrawTextFTJS & | operator= (const DrawTextFTJS &)=delete
DrawTextFTJS & | operator= (DrawTextFTJS &&)=delete
int | MoveToFunctionImpl (const FT_Vector *to) override
int | LineToFunctionImpl (const FT_Vector *to) override
int | ConicToFunctionImpl (const FT_Vector *control, const FT_Vector *to) override
int | CubicToFunctionImpl (const FT_Vector *controlOne, const FT_Vector *controlTwo, const FT_Vector *to) override
double | extractOutline () override
Public Member Functions inherited from RDKit::MolDraw2D_detail::DrawTextFT
| ~DrawTextFT () override
| DrawTextFT (double max_fnt_sz, double min_fnt_sz, const std::string &font_file)
| DrawTextFT (const DrawTextFT &)=delete
| DrawTextFT (DrawTextFT &&)=delete
DrawTextFT & | operator= (const DrawTextFT &)=delete
DrawTextFT & | operator= (DrawTextFT &&)=delete
void | drawChar (char c, const Point2D &cds) override
std::string | getFontFile () const override
void | setFontFile (const std::string &font_file) override
double | fontCoordToDrawCoord (FT_Pos fc) const
void | fontPosToDrawPos (FT_Pos fx, FT_Pos fy, double &dx, double &dy) const
void | getStringRects (const std::string &text, std::vector< std::shared_ptr< StringRect > > &rects, std::vector< TextDrawType > &draw_modes, std::vector< char > &draw_chars) const override
void | calcGlyphBBox (char c, FT_Pos &x_min, FT_Pos &y_min, FT_Pos &x_max, FT_Pos &y_max, FT_Pos &advance) const
Public Member Functions inherited from RDKit::MolDraw2D_detail::DrawText
virtual | ~DrawText ()=0
| DrawText (double max_fnt_sz, double min_fnt_sz)
| DrawText (const DrawText &)=delete
| DrawText (DrawText &&)=delete
DrawText & | operator= (const DrawText &)=delete
DrawText & | operator= (DrawText &&)=delete
DrawColour const & | colour () const
void | setColour (const DrawColour &col)
double | fontSize () const
void | setFontSize (double new_size)
double | baseFontSize () const
void | setBaseFontSize (double new_size)
double | maxFontSize () const
void | setMaxFontSize (double new_max)
double | minFontSize () const
void | setMinFontSize (double new_max)
double | fontScale () const
bool | setFontScale (double new_scale, bool ignoreLimits=false)
virtual void | getStringSize (const std::string &label, double &label_width, double &label_height) const
| using the current scale, work out the size of the label
void | getStringExtremes (const std::string &label, OrientType orient, double &x_min, double &y_min, double &x_max, double &y_max, bool dontSplit=false) const
void | getStringRects (const std::string &text, OrientType orient, std::vector< std::shared_ptr< StringRect > > &rects, std::vector< TextDrawType > &draw_modes, std::vector< char > &draw_chars, bool dontSplit=false, TextAlignType textAlign=TextAlignType::MIDDLE) const
virtual void | drawString (const std::string &str, const Point2D &cds, TextAlignType align)
| drawString centres the string on cds.
void | drawString (const std::string &label, const Point2D &cds, OrientType orient)
void | adjustLineForString (const std::string &label, OrientType orient, const Point2D &end1, Point2D &end2) const
void | drawStringRects (const std::string &label, OrientType orient, TextAlignType talign, const Point2D &cds, MolDraw2D &mol_draw) const
bool | doesRectIntersect (const std::string &label, OrientType orient, const Point2D &cds, const StringRect &rect) const
bool | doesRectIntersect (const std::vector< std::shared_ptr< StringRect > > &rects, const Point2D &cds, const StringRect &rect) const
bool | doesLineIntersect (const std::string &label, OrientType orient, const Point2D &cds, const Point2D &end1, const Point2D &end2, double padding) const
bool | doesLineIntersect (const std::vector< std::shared_ptr< StringRect > > &rects, const Point2D &cds, const Point2D &end1, const Point2D &end2, double padding) const
bool | doesStringIntersect (const std::vector< std::shared_ptr< StringRect > > &rects, const Point2D &cds1, const std::string &label2, OrientType orient2, const Point2D &cds2) const
bool | doesStringIntersect (const std::string &label1, OrientType orient1, const Point2D &cds1, const std::string &label2, OrientType orient2, const Point2D &cds2) const
virtual void | alignString (TextAlignType align, const std::vector< TextDrawType > &draw_modes, std::vector< std::shared_ptr< StringRect > > &rects) const
void | adjustStringRectsForSuperSubScript (const std::vector< TextDrawType > &draw_modes, std::vector< std::shared_ptr< StringRect > > &rects) const
double | selectScaleFactor (char c, TextDrawType draw_type) const
void | drawChars (const Point2D &a_cds, const std::vector< std::shared_ptr< StringRect > > &rects, const std::vector< TextDrawType > &draw_modes, const std::vector< char > &draw_chars)

## Public Attributes

emscripten::val & | context_
Public Attributes inherited from RDKit::MolDraw2D_detail::DrawTextFT
FT_Library | library_
FT_Face | face_
std::string | font_file_
double | x_trans_
double | y_trans_
FT_Pos | string_y_max_
double | em_scale_
Public Attributes inherited from RDKit::MolDraw2D_detail::DrawText
DrawColour | colour_
double | font_scale_
double | max_font_size_
double | min_font_size_
double | base_font_size_ = DEFAULT_FONT_SCALE

## Additional Inherited Members

Static Public Attributes inherited from RDKit::MolDraw2D_detail::DrawText
static constexpr double | DEFAULT_FONT_SCALE
static constexpr double | SUBS_SCALE = 0.66
static constexpr double | SUPER_SCALE = 0.66

## Detailed Description

Definition at line 25 of file DrawTextFTJS.h.

## Constructor & Destructor Documentation

## ~DrawTextFTJS()

RDKit::MolDraw2D_detail::DrawTextFTJS::~DrawTextFTJS | ( |  | ) |

override default

## DrawTextFTJS() [1/3]

RDKit::MolDraw2D_detail::DrawTextFTJS::DrawTextFTJS | ( | double | max_fnt_sz,
|  | double | min_fnt_sz,
|  | const std::string & | font_file,
|  | emscripten::val & | context )

Referenced by DrawTextFTJS(), DrawTextFTJS(), operator=(), and operator=().

## DrawTextFTJS() [2/3]

RDKit::MolDraw2D_detail::DrawTextFTJS::DrawTextFTJS | ( | const DrawTextFTJS & |  | ) |

delete

References DrawTextFTJS().

## DrawTextFTJS() [3/3]

RDKit::MolDraw2D_detail::DrawTextFTJS::DrawTextFTJS | ( | DrawTextFTJS && |  | ) |

delete

References DrawTextFTJS().

## Member Function Documentation

## ConicToFunctionImpl()

int RDKit::MolDraw2D_detail::DrawTextFTJS::ConicToFunctionImpl | ( | const FT_Vector * | control,
|  | const FT_Vector * | to )

override virtual

Implements RDKit::MolDraw2D_detail::DrawTextFT.

## CubicToFunctionImpl()

int RDKit::MolDraw2D_detail::DrawTextFTJS::CubicToFunctionImpl | ( | const FT_Vector * | controlOne,
|  | const FT_Vector * | controlTwo,
|  | const FT_Vector * | to )

override virtual

Implements RDKit::MolDraw2D_detail::DrawTextFT.

## extractOutline()

double RDKit::MolDraw2D_detail::DrawTextFTJS::extractOutline | ( |  | ) |

override virtual

Reimplemented from RDKit::MolDraw2D_detail::DrawTextFT.

## LineToFunctionImpl()

int RDKit::MolDraw2D_detail::DrawTextFTJS::LineToFunctionImpl | ( | const FT_Vector * | to | ) |

override virtual

Implements RDKit::MolDraw2D_detail::DrawTextFT.

## MoveToFunctionImpl()

int RDKit::MolDraw2D_detail::DrawTextFTJS::MoveToFunctionImpl | ( | const FT_Vector * | to | ) |

override virtual

Implements RDKit::MolDraw2D_detail::DrawTextFT.

## operator=() [1/2]

DrawTextFTJS & RDKit::MolDraw2D_detail::DrawTextFTJS::operator= | ( | const DrawTextFTJS & |  | ) |

delete

References DrawTextFTJS().

## operator=() [2/2]

DrawTextFTJS & RDKit::MolDraw2D_detail::DrawTextFTJS::operator= | ( | DrawTextFTJS && |  | ) |

delete

References DrawTextFTJS().

## Member Data Documentation

## context_

emscripten::val& RDKit::MolDraw2D_detail::DrawTextFTJS::context_

Definition at line 47 of file DrawTextFTJS.h.

The documentation for this class was generated from the following file:

- DrawTextFTJS.h